	.module main.c
	.area text(rom, con, rel)
	.dbfile ./main.c
	.dbfunc e Setup_PSoC _Setup_PSoC fV
_Setup_PSoC::
	.dbline -1
	.dbline 28
; //-----------------------------------------------------------------------------
; // PSoC RF Demo RX 
; // 
; // PSoCEval1 Connections:
; //      P1.2    : Digital Input,  IRQ
; //      P1.3    : Digital Output, nSS
; //      P1.4    : Digital Output, SCLK
; //      P1.5    : Digital Output, MOSI
; //      P1.6    : Digital Input,  MISO
; //      P1.7    : Digital Output, RST
; //-----------------------------------------------------------------------------
; 
; #include <m8c.h>                       
; #include "PSoCAPI.h"
; #include "PSoCgpioint.h"
; #include "lpregs.h"
; #include "lpradio.h"
; 
; #define PAYLOAD_LENGTH    2  // 1-15
; #define FREQUENCY        15  // 0-83
; #define SOP_PN_CODE       4  // 0-11
; #define DATA_RATE        DATMODE_8DR
; 
; #define DAC_LOW_LIMIT    10
; #define DAC_HIGH_LIMIT  140
; #define OFF_THRESHOLD    10
; 
; void Setup_PSoC(void){
	.dbline 29
;     M8C_EnableGInt;
		or  F, 01h

	.dbline 30
;     LCD_Start();
	push X
	xcall _LCD_Start
	.dbline 31
;     PWM8_Start();
	xcall _PWM8_Start
	.dbline 32
;     DigBuf_Start(); 
	xcall _DigBuf_Start
	.dbline 33
;     CMPPRG_Start(1);
	mov A,1
	xcall _CMPPRG_Start
	.dbline 34
;     DAC8_Start(2);
	mov A,2
	xcall _DAC8_Start
	.dbline 35
;     DAC8_WriteBlind(0x00); 
	mov A,0
	xcall _DAC8_WriteBlind
	.dbline 36
;     ERROR_AMP_Start(1);
	mov A,1
	xcall _ERROR_AMP_Start
	.dbline 37
;     PGA_BUF_Start(1);
	mov A,1
	xcall _PGA_BUF_Start
	pop X
	.dbline -2
	.dbline 38
; }
L1:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e Setup_Radio _Setup_Radio fV
_Setup_Radio::
	.dbline -1
	.dbline 40
; 
; void Setup_Radio(void){
	.dbline 41
;     SPIM_Radio_Start(SPIM_Radio_SPIM_MODE_0 | SPIM_Radio_SPIM_MSB_FIRST); // Start the SPI module
	push X
	mov A,0
	xcall _SPIM_Radio_Start
	.dbline 42
;     RadioInit(ACK_EN|END_STATE_SLEEP|ACK_TO_15X, DATCODE_LEN_32|DATMODE_8DR);
	mov X,8
	mov A,-125
	xcall _RadioInit
	.dbline 45
;     // Data Transmission Modes: DATMODE_1MBPS, DATMODE_8DR, DATMODE_DDR, DATMODE_SDR     
;     
;     RadioSetFrequency(FREQUENCY);
	mov A,15
	xcall _RadioSetFrequency
	.dbline 46
;     RadioSetSopPnCode(SOP_PN_CODE);
	mov A,4
	xcall _RadioSetSopPnCode
	.dbline 47
;     RadioSetLength(PAYLOAD_LENGTH);    
	mov A,2
	xcall _RadioSetLength
	pop X
	.dbline -2
	.dbline 48
; }
L2:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e display _display fV
;           rssi -> X-7
;       rx_count -> X-6
;           mode -> X-5
;        rx_data -> X-4
_display::
	.dbline -1
	push X
	mov X,SP
	.dbline 50
; 
; void display(unsigned char rx_data, unsigned char mode, unsigned char rx_count, unsigned char rssi ){
	.dbline 51
;     LCD_Position(0,0);
	push X
	mov A,0
	mov X,A
	xcall _LCD_Position
	.dbline 52
;     LCD_PrCString("D=");
	mov A,>L4
	push A
	mov A,<L4
	mov X,A
	pop A
	xcall _LCD_PrCString
	pop X
	.dbline 53
;     LCD_PrHexByte(rx_data);
	push X
	mov A,[X-4]
	xcall _LCD_PrHexByte
	.dbline 55
; 
;     LCD_Position(0,8);
	mov X,8
	mov A,0
	xcall _LCD_Position
	.dbline 56
;     LCD_PrCString("M=");                
	mov A,>L5
	push A
	mov A,<L5
	mov X,A
	pop A
	xcall _LCD_PrCString
	pop X
	.dbline 57
;     LCD_PrHexByte(mode);
	push X
	mov A,[X-5]
	xcall _LCD_PrHexByte
	.dbline 59
; 
;     LCD_Position(1,0);
	mov X,0
	mov A,1
	xcall _LCD_Position
	.dbline 60
;     LCD_PrCString("C=");
	mov A,>L6
	push A
	mov A,<L6
	mov X,A
	pop A
	xcall _LCD_PrCString
	pop X
	.dbline 61
;     LCD_PrHexByte(rx_count);
	push X
	mov A,[X-6]
	xcall _LCD_PrHexByte
	.dbline 63
;     
;     LCD_Position(1,8);
	mov X,8
	mov A,1
	xcall _LCD_Position
	.dbline 64
;     LCD_PrCString("RSSI=");
	mov A,>L7
	push A
	mov A,<L7
	mov X,A
	pop A
	xcall _LCD_PrCString
	pop X
	.dbline 65
;     LCD_PrHexByte(rssi);
	push X
	mov A,[X-7]
	xcall _LCD_PrHexByte
	pop X
	.dbline -2
	.dbline 66
; }
L3:
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l rssi -7 c
	.dbsym l rx_count -6 c
	.dbsym l mode -5 c
	.dbsym l rx_data -4 c
	.dbend
	.dbfunc e update_dac _update_dac fV
;           data -> X-4
_update_dac::
	.dbline -1
	push X
	mov X,SP
	.dbline 68
; 
; void update_dac(unsigned char data){
	.dbline 70
;     
;     if(data < DAC_LOW_LIMIT) data = 0;
	cmp [X-4],10
	jnc L9
X0:
	.dbline 70
	mov [X-4],0
L9:
	.dbline 71
;     if(data > DAC_HIGH_LIMIT) data = DAC_HIGH_LIMIT;
	mov A,-116
	cmp A,[X-4]
	jnc L11
X1:
	.dbline 71
	mov [X-4],-116
L11:
	.dbline 73
;     
;     DAC8_WriteBlind(data);    
	push X
	mov A,[X-4]
	xcall _DAC8_WriteBlind
	pop X
	.dbline -2
	.dbline 75
; 
; }
L8:
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l data -4 c
	.dbend
	.dbfunc e main _main fV
; RxPayloadBuffer -> X+7
; rx_packet_size -> X+6
;           mode -> X+5
;       rx_count -> X+4
;   rx_done_flag -> X+3
;           rssi -> X+2
;        rx_data -> X+1
;       rx_state -> X+0
_main::
	.dbline -1
	push X
	mov X,SP
	add SP,9
	.dbline 77
; 
; void main(){
	.dbline 80
; 
;     unsigned char RxPayloadBuffer[PAYLOAD_LENGTH];
;     unsigned char rx_state=0, rx_packet_size, rx_data=0, mode=0, rx_count=0, rssi=0, rx_done_flag=0;
	mov [X+0],0
	.dbline 80
	mov [X+1],0
	.dbline 80
	mov [X+5],0
	.dbline 80
	mov [X+4],0
	.dbline 80
	mov [X+2],0
	.dbline 80
	mov [X+3],0
	.dbline 82
;     
;     Setup_PSoC();
	xcall _Setup_PSoC
	.dbline 83
;     Setup_Radio();
	xcall _Setup_Radio
	.dbline 85
; 
;     RadioSetPtr(RxPayloadBuffer);
	mov [__r1],X
	add [__r1],7
	push X
	mov A,[__r0]
	push A
	mov A,[__r1]
	mov X,A
	pop A
	xcall _RadioSetPtr
	.dbline 86
;     RadioStartReceive();
	xcall _RadioStartReceive
	pop X
	xjmp L15
L14:
	.dbline 88
;     
;     while(1){
	.dbline 90
; 
;         rx_state = RadioGetReceiveState();
	push X
	xcall _RadioGetReceiveState
	pop X
	mov [X+0],A
	.dbline 91
;         if(rx_state & RADIO_COMPLETE){
	tst [X+0],2
	jz L17
	.dbline 91
	.dbline 92
;             rx_packet_size = RadioEndReceive();       
	push X
	xcall _RadioEndReceive
	pop X
	mov [X+6],A
	.dbline 93
;             rx_count++;
	inc [X+4]
	.dbline 94
;             if(!(rx_state & RADIO_ERROR)){
	tst [X+0],1
	jnz L19
	.dbline 94
	.dbline 95
;                 if(rx_packet_size == PAYLOAD_LENGTH){
	cmp [X+6],2
	jnz L21
	.dbline 95
	.dbline 96
;                     rx_data = RxPayloadBuffer[0];
	mov A,[X+7]
	mov [X+1],A
	.dbline 97
;                     mode = RxPayloadBuffer[1];
	mov A,[X+8]
	mov [X+5],A
	.dbline 98
;                     rssi = (RadioGetRssi() & 0x1F);
	push X
	xcall _RadioGetRssi
	pop X
	and A,31
	mov [X+2],A
	.dbline 99
;                     rx_done_flag = 1;
	mov [X+3],1
	.dbline 100
;                 }
L21:
	.dbline 101
;             }
L19:
	.dbline 102
;             RadioStartReceive();            
	push X
	xcall _RadioStartReceive
	pop X
	.dbline 103
;         }
L17:
	.dbline 105
;         
;         if(rx_done_flag){
	cmp [X+3],0
	jz L24
	.dbline 105
	.dbline 106
;             if(rx_data < OFF_THRESHOLD)DigBuf_Stop();
	cmp [X+1],10
	jnc L26
X3:
	.dbline 106
	push X
	xcall _DigBuf_Stop
	pop X
	xjmp L27
L26:
	.dbline 107
;             else DigBuf_Start();
	push X
	xcall _DigBuf_Start
	pop X
L27:
	.dbline 108
;             update_dac(rx_data);
	mov A,[X+1]
	push A
	xcall _update_dac
	add SP,-1
	.dbline 109
;             rx_done_flag = 0;
	mov [X+3],0
	.dbline 110
;             RxSig_LED_Invert();      
	push X
	xcall _RxSig_LED_Invert
	pop X
	.dbline 111
;         }
L24:
	.dbline 113
;         
;         display(rx_data, mode, rx_count, rssi);
	mov A,[X+2]
	push A
	mov A,[X+4]
	push A
	mov A,[X+5]
	push A
	mov A,[X+1]
	push A
	xcall _display
	add SP,-4
	.dbline 114
;         if(rssi>0x10) RSSI_LED_On();
	mov A,16
	cmp A,[X+2]
	jnc L28
X4:
	.dbline 114
	push X
	xcall _RSSI_LED_On
	pop X
	xjmp L29
L28:
	.dbline 115
;         else RSSI_LED_Off();                     
	push X
	xcall _RSSI_LED_Off
	pop X
L29:
	.dbline 116
L15:
	.dbline 88
	xjmp L14
X2:
	.dbline -2
	.dbline 117
;     }
; }
L13:
	add SP,-9
	pop X
	.dbline 0 ; func end
	jmp .
	.dbsym l RxPayloadBuffer 7 A[2:2]c
	.dbsym l rx_packet_size 6 c
	.dbsym l mode 5 c
	.dbsym l rx_count 4 c
	.dbsym l rx_done_flag 3 c
	.dbsym l rssi 2 c
	.dbsym l rx_data 1 c
	.dbsym l rx_state 0 c
	.dbend
	.area lit(rom, con, rel)
L7:
	.byte 'R,'S,'S,'I,61,0
L6:
	.byte 'C,61,0
L5:
	.byte 'M,61,0
L4:
	.byte 'D,61,0
