;;*****************************************************************************
;;*****************************************************************************
;;  FILENAME: SleepTimer.inc
;;   Version: 1.0, Updated on 2006/05/15 at 15:10:02
;;  Generated by PSoC Designer ver 4.4  b1884 : 14 Jan, 2007
;;
;;  DESCRIPTION: Assembler declarations for the SleepTimer user module interface
;;               for the 22/24/27/29/42xxx PSoC family of devices
;;-----------------------------------------------------------------------------
;;  Copyright (c) Cypress MicroSystems 2000-2006. All Rights Reserved.
;;*****************************************************************************
;;*****************************************************************************

include "m8c.inc"


;--------------------------------------------------
; Constants for SleepTimer API's.
;--------------------------------------------------

SleepTimer_INT_REG:                        equ 0x0e0
SleepTimer_INT_MASK:                       equ 0x40

SleepTimer_TICK_CNTR_SIZE:                  equ  2h
SleepTimer_PSOC_TYPE:                       equ  1

IF (SleepTimer_PSOC_TYPE)                   ; 22/24/27/29xxx Family

; Frequency of sleep timer interrupts
SleepTimer_1_HZ:                            equ 0x18
SleepTimer_8_HZ:                            equ 0x10
SleepTimer_64_HZ:                           equ 0x08
SleepTimer_512_HZ:                          equ 0x00
SleepTimer_CLOCK_MASK:                      equ 0x18
ELSE                                        ; 42020 Family

; Frequency of sleep timer interrupts
SleepTimer_1_HZ:                            equ 0x03
SleepTimer_8_HZ:                            equ 0x02
SleepTimer_64_HZ:                           equ 0x01
SleepTimer_512_HZ:                          equ 0x00
SleepTimer_CLOCK_MASK:                      equ 0x03
ENDIF


SleepTimer_FORCE_RELOAD:                    equ 0x01
SleepTimer_WAIT_RELOAD:                     equ 0x00
