//*****************************************************************************
//*****************************************************************************
//  FILENAME: SleepTimer.h
//   Version: 1.0, Updated on 2006/05/15 at 15:10:02
//  Generated by PSoC Designer ver 4.4  b1884 : 14 Jan, 2007
//
//  DESCRIPTION: SleepTimer User Module C Language interface file
//               for the 22/24/27/29/42xxx PSoC family of devices
//-----------------------------------------------------------------------------
//  Copyright (c) Cypress MicroSystems 2000-2006. All Rights Reserved.
//*****************************************************************************
//*****************************************************************************

#include <m8c.h>
#define SleepTimer_TICK_CNTR_SIZE             2
#define SleepTimer_PSOC_TYPE                  1

#pragma fastcall16 SleepTimer_EnableInt                 //                 Proxy 1
#pragma fastcall16 SleepTimer_DisableInt                //                 Proxy 1
#pragma fastcall16 SleepTimer_Start                     //                 Proxy 1
#pragma fastcall16 SleepTimer_Stop                      //                 Proxy 1
#pragma fastcall16 SleepTimer_SetInterval               //                 Proxy 1
#pragma fastcall16 SleepTimer_SetTimer
#pragma fastcall16 SleepTimer_bGetTimer

#pragma fastcall16 SleepTimer_SyncWait                  //                 Proxy 1
#pragma fastcall16 SleepTimer_TickWait                  //                 Proxy 1

#pragma fastcall16 SleepTimer_bGetTickCntr              //                 Proxy 2


#if ( SleepTimer_TICK_CNTR_SIZE & (4|2) )
#pragma fastcall16 SleepTimer_iGetTickCntr              //                 Proxy 4
#endif

#if ( SleepTimer_TICK_CNTR_SIZE & 4 )
#pragma fastcall16 SleepTimer_lGetTickCntr              //                 Proxy 4
#endif

//-------------------------------------------------
// Prototypes of the SleepTimer API.
//-------------------------------------------------

extern void SleepTimer_EnableInt(void);
extern void SleepTimer_DisableInt(void);
extern void SleepTimer_Start(void);
extern void SleepTimer_Stop(void);
extern void SleepTimer_SetInterval(BYTE bInterval);
extern void SleepTimer_SyncWait(BYTE bTicks, BYTE bMode);
extern void SleepTimer_TickWait(BYTE bTicks);
extern void SleepTimer_SetTimer(BYTE bNewTimerValue);
extern BYTE SleepTimer_bGetTimer( void );

extern BYTE SleepTimer_bGetTickCntr(void);

#if ( SleepTimer_TICK_CNTR_SIZE & (4|2) )
extern unsigned int  SleepTimer_iGetTickCntr(void);
#define ST_INT_VALID
#endif

#if ( SleepTimer_TICK_CNTR_SIZE & 4 )
extern unsigned long * SleepTimer_lGetTickCntr(unsigned long * lptr);
#define ST_LONG_VALID
#endif

#if ( SleepTimer_PSOC_TYPE )                 // 22/24/27/29xxx Family
// Frequency of sleep timer interrupts
#define SleepTimer_1_HZ                      0x18
#define SleepTimer_8_HZ                      0x10
#define SleepTimer_64_HZ                     0x08
#define SleepTimer_512_HZ                    0x00
#else                                        // 42020 Family

// Frequency of sleep timer interrupts
#define SleepTimer_1_HZ                      0x03
#define SleepTimer_8_HZ                      0x02
#define SleepTimer_64_HZ                     0x01
#define SleepTimer_512_HZ                    0x00
#endif

#define SleepTimer_FORCE_RELOAD              0x01
#define SleepTimer_WAIT_RELOAD               0x00
extern BYTE SleepTimer_fTick;



// end of file SleepTimer.h
