	.module main.c
	.area text(rom, con, rel)
	.dbfile ./main.c
	.dbfunc e Setup_PSoC _Setup_PSoC fV
_Setup_PSoC::
	.dbline -1
	.dbline 31
; //-----------------------------------------------------------------------------
; // PSoC RF Remote LED-LIght Demo TX
; // 
; // PSoCEval1 Connections:
; //      P0.1    : Analog Input,   0V-Vdd range VR
; //      P1.2    : Digital Input,  IRQ
; //      P1.3    : Digital Output, nSS
; //      P1.4    : Digital Output, SCLK
; //      P1.5    : Digital Output, MOSI
; //      P1.6    : Digital Input,  MISO
; //      P1.7    : Digital Output, RST
; //
; // Build by Imagecraft C-comiler, PSoC Designer Version 4.4 with SP2
; //-----------------------------------------------------------------------------
; 
; #include <m8c.h>                       
; #include "PSoCAPI.h"
; #include "PSoCgpioint.h"
; #include "lpregs.h"
; #include "lpradio.h"
; #include "stdlib.h"
; 
; #define PAYLOAD_LENGTH    2  // 1-15
; #define FREQUENCY        15  // 0-98
; #define SOP_PN_CODE       4  // 0-11
; #define DATA_RATE        DATMODE_8DR
; 
; #define ADC_RESOLUTION  256                    // ADC resolution
; #define BG_SCALE        ((ADC_RESOLUTION)/64)  // BarGraph scale factor
; 
; void Setup_PSoC(void){
	.dbline 32
;     M8C_EnableGInt;
		or  F, 01h

	.dbline 33
;     PGA_Start(3);             // Start the PGA module
	push X
	mov A,3
	xcall _PGA_Start
	.dbline 34
;     ADCINC_Start(3);          // Start the ADC module
	mov A,3
	xcall _ADCINC_Start
	.dbline 35
;     SleepTimer_Start();
	xcall _SleepTimer_Start
	.dbline 36
;     SleepTimer_EnableInt();     
	xcall _SleepTimer_EnableInt
	.dbline 37
;     LCD_Start();              // Start the LCD module
	xcall _LCD_Start
	.dbline 38
;     LCD_InitBG(LCD_SOLID_BG); // Initialize LCD Bargraph
	mov A,0
	xcall _LCD_InitBG
	.dbline 39
;     LCD_Position(0,0);
	mov A,0
	mov X,A
	xcall _LCD_Position
	.dbline 40
;     LCD_PrCString("TX   MODE=");
	mov A,>L2
	push A
	mov A,<L2
	mov X,A
	pop A
	xcall _LCD_PrCString
	pop X
	.dbline -2
	.dbline 41
; }
L1:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e Setup_Radio _Setup_Radio fV
_Setup_Radio::
	.dbline -1
	.dbline 43
; 
; void Setup_Radio(void){
	.dbline 45
;     // Start SPI Module
;     SPIM_Radio_Start(SPIM_Radio_SPIM_MODE_0 | SPIM_Radio_SPIM_MSB_FIRST);
	push X
	mov A,0
	xcall _SPIM_Radio_Start
	.dbline 47
;     // Initialize Radio
;     RadioInit(ACK_EN|END_STATE_SLEEP|ACK_TO_15X, PA_N10_DBM|DATCODE_LEN_32|DATMODE_8DR);
	mov X,12
	mov A,-125
	xcall _RadioInit
	.dbline 52
;     
;     // RF Power Amp settings: PA_N30_DBM, PA_N25_DBM, PA_N20_DBM, PA_N15_DBM, PA_N10_DBM, PA_N5_DBM, PA_0_DBM, PA_4_DBM
;     // Data Transmission Modes: DATMODE_1MBPS, DATMODE_8DR, DATMODE_DDR, DATMODE_SDR 
;     
;     RadioSetFrequency(FREQUENCY);
	mov A,15
	xcall _RadioSetFrequency
	.dbline 53
;     RadioSetSopPnCode(SOP_PN_CODE);
	mov A,4
	xcall _RadioSetSopPnCode
	.dbline 54
;     RadioSetLength(PAYLOAD_LENGTH);
	mov A,2
	xcall _RadioSetLength
	pop X
	.dbline -2
	.dbline 55
; }
L3:
	.dbline 0 ; func end
	ret
	.dbend
	.area lit(rom, con, rel)
L5:
	.byte 0
	.byte 0
	.area text(rom, con, rel)
	.dbfile ./main.c
	.dbfunc e main _main fV
;   bar_position -> X+4
; TxPayloadBuffer -> X+2
;           mode -> X+1
;       adc_read -> X+0
_main::
	.dbline -1
	push X
	mov X,SP
	add SP,5
	.dbline 57
; 
; void main(){
	.dbline 59
; 
;     unsigned char TxPayloadBuffer[PAYLOAD_LENGTH] = {0x00};
	mov [__r1],<L5
	mov [__r0],>L5
	mov [__r3],X
	add [__r3],2
	push X
	mov [__rX],0
	mov A,[__r0]
	mov X,[__r1]
X1:
	push A
	romx
	mvi [__r3],A
	pop A
	inc X
	adc A,0
	inc [__rX]
	cmp [__rX],2
	jnz X1
	pop X
	.dbline 60
;     unsigned char adc_read=0, mode=0, bar_position=0;
	mov [X+0],0
	.dbline 60
	mov [X+1],0
	.dbline 60
	mov [X+4],0
	.dbline 62
; 
;     Setup_PSoC();
	xcall _Setup_PSoC
	.dbline 63
;     Setup_Radio();
	xcall _Setup_Radio
	.dbline 64
;     RadioSetPtr(TxPayloadBuffer);
	mov [__r1],X
	add [__r1],2
	push X
	mov A,[__r0]
	push A
	mov A,[__r1]
	mov X,A
	pop A
	xcall _RadioSetPtr
	pop X
	xjmp L7
L6:
	.dbline 66
;        
;     while(1){
	.dbline 68
;         // Read POT value
;         ADCINC_GetSamples(1);   
	push X
	mov A,1
	xcall _ADCINC_GetSamples
	pop X
L9:
	.dbline 69
L10:
	.dbline 69
;         while(ADCINC_fIsDataAvailable() == 0); // Wait until ADC data ready
	push X
	xcall _ADCINC_fIsDataAvailable
	pop X
	cmp A,0
	jz L9
	.dbline 70
;         adc_read = ADCINC_wClearFlagGetData(); // Get result
	push X
	xcall _ADCINC_wClearFlagGetData
	pop X
	mov [X+0],A
	.dbline 73
;         
;         // Load TX buffer with data
;         TxPayloadBuffer[0] = adc_read;
	mov A,[X+0]
	mov [X+2],A
	.dbline 74
;         TxPayloadBuffer[1] = mode;
	mov A,[X+1]
	mov [X+3],A
	.dbline 77
;         
;         // Start the transmit to send the packet
;         RadioStartTransmit(0, PAYLOAD_LENGTH);
	push X
	mov X,2
	mov A,0
	xcall _RadioStartTransmit
	pop X
L13:
	.dbline 80
L14:
	.dbline 80
	push X
	xcall _RadioGetTransmitState
	pop X
	mov [__r0],A
	tst [__r0],2
	jz L13
	.dbline 83
	push X
	xcall _RadioEndTransmit
	.dbline 86
	mov X,10
	mov A,0
	xcall _LCD_Position
	pop X
	.dbline 87
	push X
	mov A,[X+1]
	xcall _LCD_PrHexByte
	.dbline 88
	mov X,0
	mov A,1
	xcall _LCD_Position
	pop X
	.dbline 89
	push X
	mov A,[X+0]
	xcall _LCD_PrHexByte
	pop X
	.dbline 90
	mov A,4
	push A
	mov A,[X+0]
	push A
	xcall __divmodu_8X8_8
	pop A
	mov [X+4],A
	add SP,-1
	.dbline 91
	push X
	mov A,[X+4]
	push A
	mov A,13
	push A
	mov A,3
	push A
	mov A,1
	push A
	xcall _LCD_DrawBG
	add SP,-4
	.dbline 93
	xcall _LED_Invert
	.dbline 95
	mov X,0
	mov A,32
	xcall _SleepTimer_SyncWait
	pop X
	.dbline 96
	inc [X+1]
	.dbline 97
L7:
	.dbline 66
	xjmp L6
X0:
	.dbline -2
	.dbline 98
;         
;         // Wait for the transmit to return a complete status
;         while(!(RadioGetTransmitState() & RADIO_COMPLETE));
;         
;         // Complete the transmit operation
;         RadioEndTransmit();
;         
;         // Display the POT value on LCD
;         LCD_Position(0,10);
;         LCD_PrHexByte(mode);
;         LCD_Position(1,0);
;         LCD_PrHexByte(adc_read);
;         bar_position = (BYTE)(adc_read/BG_SCALE);
;         LCD_DrawBG(1, 3, 13, bar_position);
;         
;         LED_Invert();
; 
;         SleepTimer_SyncWait(32, SleepTimer_WAIT_RELOAD); //64Hz
;         mode++;
;     }
; }
L4:
	add SP,-5
	pop X
	.dbline 0 ; func end
	jmp .
	.dbsym l bar_position 4 c
	.dbsym l TxPayloadBuffer 2 A[2:2]c
	.dbsym l mode 1 c
	.dbsym l adc_read 0 c
	.dbend
	.area lit(rom, con, rel)
L2:
	.byte 'T,'X,32,32,32,'M,'O,'D,'E,61,0
